diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
index 9e02da7b5..e2c470172 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
@@ -7,6 +7,7 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
@@ -14,15 +15,16 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
-public class BlockLogicPistonHead extends BlockLogic
-{
+public class BlockLogicPistonHead extends BlockLogic {
     public static final int MASK_DIRECTION = 0b0000_0111;
     public static final int MASK_TYPE = 0b1111_1000;
     public static final int TYPE_NORMAL = 0;
@@ -31,27 +33,27 @@ public class BlockLogicPistonHead extends BlockLogic
 
     private final double headThickness;
     private final double shaftThickness;
-    public BlockLogicPistonHead(final Block<?> block, final double headThickness, final double shaftThickness)
-    {
-        super(block, Material.piston);
+
+    public BlockLogicPistonHead(final Block<?> block, final double headThickness, final double shaftThickness) {
+        super(block, Materials.PISTON);
         block.withHardness(0.5F);
         this.headThickness = headThickness;
         this.shaftThickness = shaftThickness;
     }
 
     @Override
-    public void onRemoved(@NotNull World world, @NotNull TilePos tilePos, int data) {
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         super.onRemoved(world, tilePos, data);
         Direction direction = getDirectionFromMeta(data);
-        if(direction == Direction.NONE) {
+        if (direction == Direction.NONE) {
             return;
         }
         Direction orientation = direction.getOpposite();
-        TilePos nextPos = tilePos.add(orientation);
+        TilePos nextPos = tilePos.add(orientation, new TilePos());
         Block<?> block = world.getBlock(nextPos);
-        if(block != null && block.getLogic() instanceof BlockLogicPistonBase) {
+        if (block != null && block.getLogic() instanceof BlockLogicPistonBase) {
             int data2 = world.getBlockData(nextPos);
-            if(BlockLogicPistonBase.isPowered(data2)) {
+            if (BlockLogicPistonBase.isPowered(data2)) {
                 block.dropWithCause(world, EnumDropCause.PROPER_TOOL, nextPos, data2, null, null);
                 world.setBlockIdNotify(nextPos, 0);
             }
@@ -59,86 +61,82 @@ public class BlockLogicPistonHead extends BlockLogic
     }
 
     @Override
-	public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-	public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         int meta = world.getBlockData(tilePos);
         return getDirectionFromMeta(meta).getSide() == side ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
     }
 
     @Override
-	public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos)
-    {
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
         return false;
     }
 
     @Override
-    public boolean canPlaceOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side)
-    {
+    public boolean canPlaceOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return false;
     }
 
 
     @Override
-    public void getCollisionAABBs(@NotNull World world, @NotNull TilePos tilePos, @NotNull AABB aabb, @NotNull List<@NotNull AABB> aabbList) {
+    public void getCollisionAABBs(@NotNull World world, @NotNull TilePosc tilePos, @NotNull AABBdc aabb, @NotNull List<@NotNull AABBdc> aabbList) {
         switch (getDirectionFromMeta(world.getBlockData(tilePos))) {
             case DOWN -> {
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F).move(tilePos), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - this.shaftThickness / 2, this.headThickness, 0.5 - this.shaftThickness / 2, 0.5 + this.shaftThickness / 2, 1 + this.headThickness, 0.5 + this.shaftThickness / 2).move(tilePos), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.5 - this.shaftThickness / 2, this.headThickness, 0.5 - this.shaftThickness / 2, 0.5 + this.shaftThickness / 2, 1 + this.headThickness, 0.5 + this.shaftThickness / 2).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
             }
             case UP -> {
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F).move(tilePos), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - this.shaftThickness / 2, -this.headThickness, 0.5 - this.shaftThickness / 2, 0.5 + this.shaftThickness / 2, 1 - this.headThickness, 0.5 + this.shaftThickness / 2).move(tilePos), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.5 - this.shaftThickness / 2, -this.headThickness, 0.5 - this.shaftThickness / 2, 0.5 + this.shaftThickness / 2, 1 - this.headThickness, 0.5 + this.shaftThickness / 2).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
             }
             case NORTH -> {
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness).move(tilePos), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - this.shaftThickness / 2, 0.5 - this.shaftThickness / 2, this.headThickness, 0.5 + this.shaftThickness / 2, 0.5 + this.shaftThickness / 2, 1 + this.headThickness).move(tilePos), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.5 - this.shaftThickness / 2, 0.5 - this.shaftThickness / 2, this.headThickness, 0.5 + this.shaftThickness / 2, 0.5 + this.shaftThickness / 2, 1 + this.headThickness).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
             }
             case SOUTH -> {
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F).move(tilePos), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - this.shaftThickness / 2, 0.5 - this.shaftThickness / 2, -this.headThickness, 0.5 + this.shaftThickness / 2, 0.5 + this.shaftThickness / 2, 1 - this.headThickness).move(tilePos), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.5 - this.shaftThickness / 2, 0.5 - this.shaftThickness / 2, -this.headThickness, 0.5 + this.shaftThickness / 2, 0.5 + this.shaftThickness / 2, 1 - this.headThickness).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
             }
             case WEST -> {
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F).move(tilePos), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.fromPool(this.headThickness, 0.5 - this.shaftThickness / 2, 0.5 - this.shaftThickness / 2, 1 + this.headThickness, 0.5 + this.shaftThickness / 2, 0.5 + this.shaftThickness / 2).move(tilePos), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(this.headThickness, 0.5 - this.shaftThickness / 2, 0.5 - this.shaftThickness / 2, 1 + this.headThickness, 0.5 + this.shaftThickness / 2, 0.5 + this.shaftThickness / 2).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
             }
             case EAST -> {
-                addIntersectingBoundingBox(aabb, AABB.fromPool(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F).move(tilePos), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.fromPool(-this.headThickness, 0.5 - this.shaftThickness / 2, 0.5 - this.shaftThickness / 2, 1 - this.headThickness, 0.5 + this.shaftThickness / 2, 0.5 + this.shaftThickness / 2).move(tilePos), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(-this.headThickness, 0.5 - this.shaftThickness / 2, 0.5 - this.shaftThickness / 2, 1 - this.headThickness, 0.5 + this.shaftThickness / 2, 0.5 + this.shaftThickness / 2).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
             }
         }
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return switch (getDirectionFromMeta(source.getBlockData(tilePos))) {
-            case DOWN -> AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F);
-            case UP -> AABB.fromPool(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
-            case NORTH -> AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness);
-            case SOUTH -> AABB.fromPool(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F);
-            case WEST -> AABB.fromPool(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F);
-            case EAST -> AABB.fromPool(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+            case DOWN -> new AABBd(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F);
+            case UP -> new AABBd(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
+            case NORTH -> new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness);
+            case SOUTH -> new AABBd(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F);
+            case WEST -> new AABBd(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F);
+            case EAST -> new AABBd(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
             default -> super.getBoundsFromState(source, tilePos);
         };
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         Direction direction = getDirectionFromMeta(world.getBlockData(tilePos));
-        if(direction == Direction.NONE) {
+        if (direction == Direction.NONE) {
             return;
         }
-        TilePos posOffset = tilePos.sub(direction);
+        TilePos posOffset = tilePos.sub(direction, new TilePos());
         Block<?> block = world.getBlock(posOffset);
         if (block != null && block.getLogic() instanceof BlockLogicPistonBase) {
             block.onNeighborChanged(world, posOffset, id);
@@ -148,12 +146,11 @@ public class BlockLogicPistonHead extends BlockLogic
     }
 
     @Override
-    public int getPistonPushReaction(@NotNull World world, @NotNull TilePos tilePos) {
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
         return Material.PISTON_CANT_PUSH;
     }
 
-    public static Direction getDirectionFromMeta(int meta)
-    {
+    public static Direction getDirectionFromMeta(int meta) {
         return Direction.getDirectionById(meta & MASK_DIRECTION);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
index f27955585..f71417664 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
@@ -4,31 +4,30 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.material.Material;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
-public class BlockLogicPistonMoving extends BlockLogic
-{
-    public BlockLogicPistonMoving(Block<?> container)
-    {
-        super(container, Material.piston);
+public class BlockLogicPistonMoving extends BlockLogic {
+    public BlockLogicPistonMoving(Block<?> container) {
+        super(container, Materials.PISTON);
         container.withHardness(-1F);
         container.withEntity(null);
     }
 
     @Override
-    public void onRemoved(@NotNull World world, @NotNull TilePos tilePos, int data) {
-        if(world.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock moving) {
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
+        if (world.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock moving) {
             moving.finalTick();
         } else {
             super.onRemoved(world, tilePos, data);
@@ -36,32 +35,28 @@ public class BlockLogicPistonMoving extends BlockLogic
     }
 
     @Override
-	public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos)
-    {
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
         return false;
     }
 
     @Override
-    public boolean canPlaceOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side)
-    {
+    public boolean canPlaceOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return false;
     }
 
     @Override
-	public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-	public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
-        if(!world.isClientSide && world.getTileEntity(tilePos) == null) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+        if (!world.isClientSide && world.getTileEntity(tilePos) == null) {
             int id = 0;
             if (world.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock piston) id = piston.getMovedId();
             world.setBlockIdNotify(tilePos, id);
@@ -77,11 +72,11 @@ public class BlockLogicPistonMoving extends BlockLogic
     }
 
     @Override
-    public void dropWithCause(@NotNull World world, @NotNull EnumDropCause dropCause, @NotNull TilePos tilePos, int data, @Nullable TileEntity tileEntity, @Nullable Player player) {
-        if(world.isClientSide) {
+    public void dropWithCause(@NotNull World world, @NotNull EnumDropCause dropCause, @NotNull TilePosc tilePos, int data, @Nullable TileEntity tileEntity, @Nullable Player player) {
+        if (world.isClientSide) {
             return;
         }
-        if(world.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock piston) {
+        if (world.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock piston) {
             Block<?> b = Blocks.getBlock(piston.getMovedId());
             if (b != null) {
                 b.dropWithCause(world, EnumDropCause.WORLD, tilePos, data, null, null);
@@ -90,7 +85,7 @@ public class BlockLogicPistonMoving extends BlockLogic
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         if (!world.isClientSide) {
             world.getTileEntity(tilePos); // Im not sure if this actually does anything anymore??
         }
@@ -102,57 +97,44 @@ public class BlockLogicPistonMoving extends BlockLogic
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         if (source.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock piston) {
             float progress = piston.getProgress(0.0F);
-            if(piston.isExtending()) {
+            if (piston.isExtending()) {
                 progress = 1.0F - progress;
             }
             return getCollisionShapeFromTileEntity(source, tilePos, piston.getMovedId(), progress, piston.getDirection());
-        } else {
-            return null;
         }
+        return null;
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
-        if(source.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock piston) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+        if (source.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock piston) {
             Block<?> block = Blocks.blocksList[piston.getMovedId()];
-            if(block == null || block == this.block) {
+            if (block == null || block == this.block) {
                 return super.getBoundsFromState(source, tilePos);
             }
-            float f = piston.getProgress(0.0F);
-            if(piston.isExtending()) {
-                f = 1.0F - f;
+            float directionStretch = piston.getProgress(0.0F);
+            if (piston.isExtending()) {
+                directionStretch = 1.0F - directionStretch;
             }
             Direction direction = piston.getDirection();
-            AABB otherBounds = block.getBoundsFromState(source, tilePos);
-            return AABB.fromPool(
-                otherBounds.minX - direction.getOffsetX() * f,
-                otherBounds.maxX - direction.getOffsetX() * f,
-                otherBounds.minY - direction.getOffsetY() * f,
-                otherBounds.maxY - direction.getOffsetY() * f,
-                otherBounds.minZ - direction.getOffsetZ() * f,
-                otherBounds.maxZ - direction.getOffsetZ() * f);
+            AABBdc otherBounds = block.getBoundsFromState(source, tilePos);
+            return otherBounds.translate(-direction.getOffsetX() * directionStretch, -direction.getOffsetY() * directionStretch, -direction.getOffsetZ() * directionStretch, new AABBd());
         }
         return super.getBoundsFromState(source, tilePos);
     }
 
-    public AABB getCollisionShapeFromTileEntity(@NotNull WorldSource source, @NotNull TilePos tilePos, int blockID, float directionStretch, @NotNull Direction direction) {
-        if(blockID == 0 || blockID == this.block.id()) {
+    public @Nullable AABBdc getCollisionShapeFromTileEntity(@NotNull WorldSource source, @NotNull TilePosc tilePos, int blockID, float directionStretch, @NotNull Direction direction) {
+        if (blockID == 0 || blockID == this.block.id()) {
             return null;
         }
-        AABB aabb = Blocks.blocksList[blockID].getCollisionAABB(source, tilePos);
-        if(aabb == null) {
+        AABBdc aabb = Blocks.blocksList[blockID].getCollisionAABB(source, tilePos);
+        if (aabb == null) {
             return null;
         } else {
-            aabb.minX -= direction.getOffsetX() * directionStretch;
-            aabb.maxX -= direction.getOffsetX() * directionStretch;
-            aabb.minY -= direction.getOffsetY() * directionStretch;
-            aabb.maxY -= direction.getOffsetY() * directionStretch;
-            aabb.minZ -= direction.getOffsetZ() * directionStretch;
-            aabb.maxZ -= direction.getOffsetZ() * directionStretch;
-            return aabb;
+            return aabb.translate(-direction.getOffsetX() * directionStretch, -direction.getOffsetY() * directionStretch, -direction.getOffsetZ() * directionStretch, new AABBd());
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
index 964a31704..b6f04adb0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
@@ -6,12 +6,12 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.phys.AABB;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
 import java.util.*;
 
@@ -123,7 +123,7 @@ public class TileEntityMovingPistonBlock extends TileEntity
         } else {
             stretch = 1.0F - stretch;
         }
-        AABB aabb = Blocks.PISTON_MOVING.getLogic().getCollisionShapeFromTileEntity(this.worldObj, new TilePos(this.x, this.y, this.z), this.movedId, stretch, this.direction);
+        AABBdc aabb = Blocks.PISTON_MOVING.getLogic().getCollisionShapeFromTileEntity(this.worldObj, new TilePos(this.x, this.y, this.z), this.movedId, stretch, this.direction);
         if (aabb == null) return;
 
         List<Entity> list = this.worldObj.getEntitiesWithinAABBExcludingEntity(null, aabb);
diff --git a/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java b/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java
index 0948e5b64..8527353b8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java
@@ -4,19 +4,20 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public interface ISupportable {
-    @NotNull ISupport getSupportConstraint(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side);
+    @NotNull ISupport getSupportConstraint(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side);
 
-    default boolean isSupported(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
-        final @Nullable Block<?> supportingBlock = world.getBlock(tilePos.add(side.getDirection()));
+    default boolean isSupported(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
+        final @Nullable Block<?> supportingBlock = world.getBlock(tilePos.add(side.getDirection(), new TilePos()));
         if (supportingBlock == null) {
             return false;
         }
 
-        final @NotNull ISupport supporting = supportingBlock.getSupport(world, tilePos.add(side.getDirection()), side.getOpposite());
+        final @NotNull ISupport supporting = supportingBlock.getSupport(world, tilePos.add(side.getDirection(), new TilePos()), side.getOpposite());
         final @NotNull ISupport supported = this.getSupportConstraint(world, tilePos, side);
         return supporting.canSupport(supported, side.getOpposite());
     }
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/Node.java b/game/core/src/main/java/net/minecraft/core/current/wire/Node.java
index 3001a2ae7..87ae2910b 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/Node.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/Node.java
@@ -5,6 +5,7 @@ import net.minecraft.core.current.util.BlockState;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 
 import java.util.Arrays;
 
@@ -16,97 +17,95 @@ import java.util.Arrays;
  */
 class Node {
 
-	// flags that encode the Node type
-	private static final int CONDUCTOR = 0b01;
-	private static final int SOURCE    = 0b10;
-
-	final World world;
-	final Node[] neighbors;
-
-	TilePos pos;
-	BlockState state;
-	boolean invalid;
-
-	private int flags;
-
-	/** The previous node in the priority queue. */
-	Node prev_node;
-	/** The next node in the priority queue. */
-	Node next_node;
-	/** The priority with which this node was queued. */
-	int priority;
-	/** The wire that queued this node for an update. */
-	WireNode neighborWire;
-
-	Node(World world) {
-		this.world = world;
-		this.neighbors = new Node[Directions.ALL.length];
-	}
-
-	@Override
-	public boolean equals(Object obj) {
-		if (this == obj) {
-			return true;
-		}
-		if (!(obj instanceof Node)) {
-			return false;
-		}
-
-		Node node = (Node)obj;
-
-		return world == node.world && pos.equals(node.pos);
-	}
-
-	@Override
-	public int hashCode() {
-		return pos.hashCode();
-	}
-
-	Node set(TilePos pos, BlockState state, boolean clearNeighbors) {
-		if (state.is(Blocks.WIRE_REDSTONE)) {
-			throw new IllegalStateException("Cannot update a regular Node to a WireNode!");
-		}
-
-		if (clearNeighbors) {
-			Arrays.fill(neighbors, null);
-		}
-
-		this.pos = pos;
-		this.state = state;
-		this.invalid = false;
-
-		this.flags = 0;
-
-		if (this.state.isConductor()) {
-			this.flags |= CONDUCTOR;
-		}
-		if (this.state.isSignalSource()) {
-			this.flags |= SOURCE;
-		}
-
-		return this;
-	}
-
-	/**
-	 * Determine the priority with which this node should be queued.
-	 */
-	int priority() {
-		return neighborWire.priority;
-	}
-
-	public boolean isWire() {
-		return false;
-	}
-
-	public boolean isConductor() {
-		return (flags & CONDUCTOR) != 0;
-	}
-
-	public boolean isSignalSource() {
-		return (flags & SOURCE) != 0;
-	}
-
-	public WireNode asWire() {
-		throw new UnsupportedOperationException("Not a WireNode!");
-	}
+    // flags that encode the Node type
+    private static final int CONDUCTOR = 0b01;
+    private static final int SOURCE = 0b10;
+
+    final World world;
+    final Node[] neighbors;
+
+    TilePos pos;
+    BlockState state;
+    boolean invalid;
+
+    private int flags;
+
+    /** The previous node in the priority queue. */
+    Node prev_node;
+    /** The next node in the priority queue. */
+    Node next_node;
+    /** The priority with which this node was queued. */
+    int priority;
+    /** The wire that queued this node for an update. */
+    WireNode neighborWire;
+
+    Node(World world) {
+        this.world = world;
+        this.neighbors = new Node[Directions.ALL.length];
+    }
+
+    @Override
+    public boolean equals(Object obj) {
+        if (this == obj) {
+            return true;
+        }
+        if (!(obj instanceof Node node)) {
+            return false;
+        }
+
+        return this.world == node.world && this.pos.equals(node.pos);
+    }
+
+    @Override
+    public int hashCode() {
+        return this.pos.hashCode();
+    }
+
+    Node set(TilePosc pos, BlockState state, boolean clearNeighbors) {
+        if (state.is(Blocks.WIRE_REDSTONE)) {
+            throw new IllegalStateException("Cannot update a regular Node to a WireNode!");
+        }
+
+        if (clearNeighbors) {
+            Arrays.fill(this.neighbors, null);
+        }
+
+        this.pos = new TilePos(pos);
+        this.state = state;
+        this.invalid = false;
+
+        this.flags = 0;
+
+        if (this.state.isConductor()) {
+            this.flags |= CONDUCTOR;
+        }
+        if (this.state.isSignalSource()) {
+            this.flags |= SOURCE;
+        }
+
+        return this;
+    }
+
+    /**
+     * Determine the priority with which this node should be queued.
+     */
+    int priority() {
+        return this.neighborWire.priority;
+    }
+
+    public boolean isWire() {
+        return false;
+    }
+
+    public boolean isConductor() {
+        return (this.flags & CONDUCTOR) != 0;
+    }
+
+    public boolean isSignalSource() {
+        return (this.flags & SOURCE) != 0;
+    }
+
+    public WireNode asWire() {
+        throw new UnsupportedOperationException("Not a WireNode!");
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
index dfb5ad8cf..578ce8242 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
@@ -7,6 +7,8 @@ import net.minecraft.core.current.util.BlockState;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.HashMap;
 import java.util.Map;
